"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getSpfxMinorVersion = exports.getTemplatesPath = void 0;
const path = __importStar(require("path"));
const consts_1 = require("./consts");
const packagePath = path.join(process.cwd(), 'package.json');
const packageJson = require(packagePath);
function getTemplatesPath(fileName) {
    const minorVersion = getSpfxMinorVersion();
    let basePath = 'templates/';
    if (fileName === consts_1.WebpackExtendFileName) {
        basePath += 'common/';
    }
    else if (minorVersion >= 12) {
        basePath += 'latest/';
    }
    else if (minorVersion >= 9 && minorVersion < 12) {
        basePath += '1.11/';
    }
    else if (minorVersion > 4 && minorVersion < 9) {
        basePath += '1.7.1/';
    }
    else if (minorVersion === 4) {
        basePath += '1.4.1/';
    }
    else {
        throw new Error(`SharePoint Framework with minor version ${minorVersion} is not supported.`);
    }
    return path.join(__dirname, '..', basePath + fileName);
}
exports.getTemplatesPath = getTemplatesPath;
function getSpfxMinorVersion() {
    const dependecyToCheck = '@microsoft/sp-build-web';
    let version = packageJson.devDependencies[dependecyToCheck];
    if (version.indexOf('~') === 0 || version.indexOf('^') === 0) {
        version = version.substr(1);
    }
    return parseInt(version.split('.')[1]);
}
exports.getSpfxMinorVersion = getSpfxMinorVersion;
//# sourceMappingURL=utils.js.map